#ifndef __DDSGATEWAY_H__
#define __DDSGATEWAY_H__

#include "MessengerTypeSupportImpl.h"
#include "MessageQueue.h"
#include "defs.h"
#include "ErlangNode.h"
#include <set>

class DDSGateway : public ErlangNode {
	Messenger::MessageDataWriter_var _messageWriter;
	std::set<erlang_pid> _subscribers;
	MessageQueue<MessageType> &_messageQueue;
public:
	DDSGateway(std::string shortName, std::string secretCookie, int port, 
		Messenger::MessageDataWriter_ptr messageWriter, MessageQueue<MessageType> &messageQueue) :
	ErlangNode(shortName, secretCookie, port), _messageWriter(messageWriter), _messageQueue(messageQueue) {}

	virtual bool OnMessage(erlang_pid /*from*/, XBuff &buff);
	virtual bool OnIdle();
};


#endif
